(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('chokidar'), require('globby'), require('fs-extra'), require('naming-style'), require('js-beautify'), require('lodash.throttle')) :
  typeof define === 'function' && define.amd ? define(['exports', 'chokidar', 'globby', 'fs-extra', 'naming-style', 'js-beautify', 'lodash.throttle'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.VueAutoRouter = {}, global.Chokidar, global.Globby, global.FsExtra, global.NamingStyle, global.JsBeautify, global.Throttle));
}(this, (function (exports, chokidar, globby, fs, namingStyle, jsBeautify, throttle) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () {
              return e[k];
            }
          });
        }
      });
    }
    n['default'] = e;
    return Object.freeze(n);
  }

  var chokidar__namespace = /*#__PURE__*/_interopNamespace(chokidar);
  var globby__default = /*#__PURE__*/_interopDefaultLegacy(globby);
  var fs__default = /*#__PURE__*/_interopDefaultLegacy(fs);
  var throttle__default = /*#__PURE__*/_interopDefaultLegacy(throttle);

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  // Copyright Joyent, Inc. and other Node contributors.
  //
  // Permission is hereby granted, free of charge, to any person obtaining a
  // copy of this software and associated documentation files (the
  // "Software"), to deal in the Software without restriction, including
  // without limitation the rights to use, copy, modify, merge, publish,
  // distribute, sublicense, and/or sell copies of the Software, and to permit
  // persons to whom the Software is furnished to do so, subject to the
  // following conditions:
  //
  // The above copyright notice and this permission notice shall be included
  // in all copies or substantial portions of the Software.
  //
  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
  // USE OR OTHER DEALINGS IN THE SOFTWARE.

  // resolves . and .. elements in a path array with directory names there
  // must be no slashes, empty elements, or device names (c:\) in the array
  // (so also no leading and trailing slashes - it does not distinguish
  // relative and absolute paths)
  function normalizeArray(parts, allowAboveRoot) {
    // if the path tries to go above the root, `up` ends up > 0
    var up = 0;
    for (var i = parts.length - 1; i >= 0; i--) {
      var last = parts[i];
      if (last === '.') {
        parts.splice(i, 1);
      } else if (last === '..') {
        parts.splice(i, 1);
        up++;
      } else if (up) {
        parts.splice(i, 1);
        up--;
      }
    }

    // if the path is allowed to go above the root, restore leading ..s
    if (allowAboveRoot) {
      for (; up--; up) {
        parts.unshift('..');
      }
    }

    return parts;
  }

  // Split a filename into [root, dir, basename, ext], unix version
  // 'root' is just a slash, or nothing.
  var splitPathRe =
      /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
  var splitPath = function(filename) {
    return splitPathRe.exec(filename).slice(1);
  };

  // path.resolve([from ...], to)
  // posix version
  function resolve() {
    var resolvedPath = '',
        resolvedAbsolute = false;

    for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
      var path = (i >= 0) ? arguments[i] : '/';

      // Skip empty and invalid entries
      if (typeof path !== 'string') {
        throw new TypeError('Arguments to path.resolve must be strings');
      } else if (!path) {
        continue;
      }

      resolvedPath = path + '/' + resolvedPath;
      resolvedAbsolute = path.charAt(0) === '/';
    }

    // At this point the path should be resolved to a full absolute path, but
    // handle relative paths to be safe (might happen when process.cwd() fails)

    // Normalize the path
    resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
      return !!p;
    }), !resolvedAbsolute).join('/');

    return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
  }
  // path.normalize(path)
  // posix version
  function normalize(path) {
    var isPathAbsolute = isAbsolute(path),
        trailingSlash = substr(path, -1) === '/';

    // Normalize the path
    path = normalizeArray(filter(path.split('/'), function(p) {
      return !!p;
    }), !isPathAbsolute).join('/');

    if (!path && !isPathAbsolute) {
      path = '.';
    }
    if (path && trailingSlash) {
      path += '/';
    }

    return (isPathAbsolute ? '/' : '') + path;
  }
  // posix version
  function isAbsolute(path) {
    return path.charAt(0) === '/';
  }

  // posix version
  function join() {
    var paths = Array.prototype.slice.call(arguments, 0);
    return normalize(filter(paths, function(p, index) {
      if (typeof p !== 'string') {
        throw new TypeError('Arguments to path.join must be strings');
      }
      return p;
    }).join('/'));
  }


  // path.relative(from, to)
  // posix version
  function relative(from, to) {
    from = resolve(from).substr(1);
    to = resolve(to).substr(1);

    function trim(arr) {
      var start = 0;
      for (; start < arr.length; start++) {
        if (arr[start] !== '') break;
      }

      var end = arr.length - 1;
      for (; end >= 0; end--) {
        if (arr[end] !== '') break;
      }

      if (start > end) return [];
      return arr.slice(start, end - start + 1);
    }

    var fromParts = trim(from.split('/'));
    var toParts = trim(to.split('/'));

    var length = Math.min(fromParts.length, toParts.length);
    var samePartsLength = length;
    for (var i = 0; i < length; i++) {
      if (fromParts[i] !== toParts[i]) {
        samePartsLength = i;
        break;
      }
    }

    var outputParts = [];
    for (var i = samePartsLength; i < fromParts.length; i++) {
      outputParts.push('..');
    }

    outputParts = outputParts.concat(toParts.slice(samePartsLength));

    return outputParts.join('/');
  }

  var sep = '/';
  var delimiter = ':';

  function dirname(path) {
    var result = splitPath(path),
        root = result[0],
        dir = result[1];

    if (!root && !dir) {
      // No dirname whatsoever
      return '.';
    }

    if (dir) {
      // It has a dirname, strip trailing slash
      dir = dir.substr(0, dir.length - 1);
    }

    return root + dir;
  }

  function basename(path, ext) {
    var f = splitPath(path)[2];
    // TODO: make this comparison case-insensitive on windows?
    if (ext && f.substr(-1 * ext.length) === ext) {
      f = f.substr(0, f.length - ext.length);
    }
    return f;
  }


  function extname(path) {
    return splitPath(path)[3];
  }
  var path = {
    extname: extname,
    basename: basename,
    dirname: dirname,
    sep: sep,
    delimiter: delimiter,
    relative: relative,
    join: join,
    isAbsolute: isAbsolute,
    normalize: normalize,
    resolve: resolve
  };
  function filter (xs, f) {
      if (xs.filter) return xs.filter(f);
      var res = [];
      for (var i = 0; i < xs.length; i++) {
          if (f(xs[i], i, xs)) res.push(xs[i]);
      }
      return res;
  }

  // String.prototype.substr - negative index don't work in IE8
  var substr = 'ab'.substr(-1) === 'b' ?
      function (str, start, len) { return str.substr(start, len) } :
      function (str, start, len) {
          if (start < 0) start = str.length + start;
          return str.substr(start, len);
      }
  ;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";

    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  var runtime = {exports: {}};

  /**
   * Copyright (c) 2014-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  (function (module) {
  var runtime = (function (exports) {

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined$1; // More compressible than void 0.
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }
    try {
      // IE 8 has a broken Object.defineProperty that only works on DOM objects.
      define({}, "");
    } catch (err) {
      define = function(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []);

      // The ._invoke method unifies the implementations of the .next,
      // .throw, and .return methods.
      generator._invoke = makeInvokeMethod(innerFn, self, context);

      return generator;
    }
    exports.wrap = wrap;

    // Try/catch helper to minimize deoptimizations. Returns a completion
    // record like context.tryEntries[i].completion. This interface could
    // have been (and was previously) designed to take a closure to be
    // invoked without arguments, but in all the cases we care about we
    // already have an existing method we want to call, so there's no need
    // to create a new function object. We can even get away with assuming
    // the method takes exactly one argument, since that happens to be true
    // in every case, so we don't have to touch the arguments object. The
    // only additional allocation required is the completion record, which
    // has a stable shape and so hopefully should be cheap to allocate.
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";

    // Returning this object from the innerFn has the same effect as
    // breaking out of the dispatch switch statement.
    var ContinueSentinel = {};

    // Dummy constructor functions that we use as the .constructor and
    // .constructor.prototype properties for functions that return Generator
    // objects. For full spec compliance, you may wish to configure your
    // minifier not to mangle the names of these two functions.
    function Generator() {}
    function GeneratorFunction() {}
    function GeneratorFunctionPrototype() {}

    // This is a polyfill for %IteratorPrototype% for environments that
    // don't natively support it.
    var IteratorPrototype = {};
    IteratorPrototype[iteratorSymbol] = function () {
      return this;
    };

    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype &&
        NativeIteratorPrototype !== Op &&
        hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      // This environment has a native %IteratorPrototype%; use it instead
      // of the polyfill.
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype =
      Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
    GeneratorFunctionPrototype.constructor = GeneratorFunction;
    GeneratorFunction.displayName = define(
      GeneratorFunctionPrototype,
      toStringTagSymbol,
      "GeneratorFunction"
    );

    // Helper for defining the .next, .throw, and .return methods of the
    // Iterator interface in terms of a single ._invoke method.
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method) {
        define(prototype, method, function(arg) {
          return this._invoke(method, arg);
        });
      });
    }

    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor
        ? ctor === GeneratorFunction ||
          // For the native GeneratorFunction constructor, the best we can
          // do is to check its .name property.
          (ctor.displayName || ctor.name) === "GeneratorFunction"
        : false;
    };

    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };

    // Within the body of any async function, `await x` is transformed to
    // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
    // `hasOwn.call(value, "__await")` to determine if the yielded value is
    // meant to be awaited.
    exports.awrap = function(arg) {
      return { __await: arg };
    };

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value &&
              typeof value === "object" &&
              hasOwn.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function(value) {
              invoke("next", value, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return PromiseImpl.resolve(value).then(function(unwrapped) {
            // When a yielded Promise is resolved, its final value becomes
            // the .value of the Promise<{value,done}> result for the
            // current iteration.
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            // If a rejected Promise was yielded, throw the rejection back
            // into the async generator function so it can be handled there.
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function(resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise =
          // If enqueue has been called before, then we want to wait until
          // all previous Promises have been resolved before calling invoke,
          // so that results are always delivered in the correct order. If
          // enqueue has not been called before, then it is important to
          // call invoke immediately, without waiting on a callback to fire,
          // so that the async generator function has the opportunity to do
          // any necessary setup in a predictable way. This predictability
          // is why the Promise constructor synchronously invokes its
          // executor callback, and why async functions synchronously
          // execute code before the first await. Since we implement simple
          // async functions in terms of async generators, it is especially
          // important to get this right, even though it requires care.
          previousPromise ? previousPromise.then(
            callInvokeWithMethodAndArg,
            // Avoid propagating failures to Promises returned by later
            // invocations of the iterator.
            callInvokeWithMethodAndArg
          ) : callInvokeWithMethodAndArg();
      }

      // Define the unified helper method that is used to implement .next,
      // .throw, and .return (see defineIteratorMethods).
      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);
    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
      return this;
    };
    exports.AsyncIterator = AsyncIterator;

    // Note that simple async functions are implemented on top of
    // AsyncIterator objects; they just return a Promise for the value of
    // the final result produced by the iterator.
    exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0) PromiseImpl = Promise;

      var iter = new AsyncIterator(
        wrap(innerFn, outerFn, self, tryLocsList),
        PromiseImpl
      );

      return exports.isGeneratorFunction(outerFn)
        ? iter // If outerFn is a generator, return the full iterator.
        : iter.next().then(function(result) {
            return result.done ? result.value : iter.next();
          });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;

      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          }

          // Be forgiving, per 25.3.3.3.3 of the spec:
          // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            // Setting context._sent for legacy support of Babel's
            // function.sent implementation.
            context.sent = context._sent = context.arg;

          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);

          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;

          var record = tryCatch(innerFn, self, context);
          if (record.type === "normal") {
            // If an exception is thrown from innerFn, we leave state ===
            // GenStateExecuting and loop back for another invocation.
            state = context.done
              ? GenStateCompleted
              : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };

          } else if (record.type === "throw") {
            state = GenStateCompleted;
            // Dispatch the exception by looping back around to the
            // context.dispatchException(context.arg) call above.
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }

    // Call delegate.iterator[context.method](context.arg) and handle the
    // result, either by returning a { value, done } result from the
    // delegate iterator, or by modifying context.method and context.arg,
    // setting context.delegate to null, and returning the ContinueSentinel.
    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];
      if (method === undefined$1) {
        // A .throw or .return when the delegate iterator has no .throw
        // method always terminates the yield* loop.
        context.delegate = null;

        if (context.method === "throw") {
          // Note: ["return"] must be used for ES3 parsing compatibility.
          if (delegate.iterator["return"]) {
            // If the delegate iterator has a return method, give it a
            // chance to clean up.
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              // If maybeInvokeDelegate(context) changed context.method from
              // "return" to "throw", let that override the TypeError below.
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError(
            "The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (! info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        // Assign the result of the finished delegate to the temporary
        // variable specified by delegate.resultName (see delegateYield).
        context[delegate.resultName] = info.value;

        // Resume execution at the desired location (see delegateYield).
        context.next = delegate.nextLoc;

        // If context.method was "throw" but the delegate handled the
        // exception, let the outer generator proceed normally. If
        // context.method was "next", forget context.arg since it has been
        // "consumed" by the delegate iterator. If context.method was
        // "return", allow the original .return call to continue in the
        // outer generator.
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }

      } else {
        // Re-yield the result returned by the delegate method.
        return info;
      }

      // The delegate iterator is finished, so forget it and continue with
      // the outer generator.
      context.delegate = null;
      return ContinueSentinel;
    }

    // Define Generator.prototype.{next,throw,return} in terms of the
    // unified ._invoke helper method.
    defineIteratorMethods(Gp);

    define(Gp, toStringTagSymbol, "Generator");

    // A Generator should always return itself as the iterator object when the
    // @@iterator function is called on it. Some browsers' implementations of the
    // iterator prototype chain incorrectly implement this, causing the Generator
    // object to not be returned from this call. This ensures that doesn't happen.
    // See https://github.com/facebook/regenerator/issues/274 for more details.
    Gp[iteratorSymbol] = function() {
      return this;
    };

    Gp.toString = function() {
      return "[object Generator]";
    };

    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      // The root entry object (effectively a try statement without a catch
      // or a finally block) gives us a place to store values thrown from
      // locations where there is no enclosing try statement.
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    exports.keys = function(object) {
      var keys = [];
      for (var key in object) {
        keys.push(key);
      }
      keys.reverse();

      // Rather than returning an object with a next method, we keep
      // things simple and return the next function itself.
      return function next() {
        while (keys.length) {
          var key = keys.pop();
          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        }

        // To avoid creating an additional object, we just hang the .value
        // and .done properties off the next function object itself. This
        // also ensures that the minifier will not anonymize the function.
        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1, next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined$1;
            next.done = true;

            return next;
          };

          return next.next = next;
        }
      }

      // Return an iterator with no values.
      return { next: doneResult };
    }
    exports.values = values;

    function doneResult() {
      return { value: undefined$1, done: true };
    }

    Context.prototype = {
      constructor: Context,

      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        // Resetting context._sent for legacy support of Babel's
        // function.sent implementation.
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;

        this.method = "next";
        this.arg = undefined$1;

        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            // Not sure about the optimal order of these conditions:
            if (name.charAt(0) === "t" &&
                hasOwn.call(this, name) &&
                !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },

      stop: function() {
        this.done = true;

        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },

      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            // If the dispatched exception was caught by a catch block,
            // then let that catch block handle the exception normally.
            context.method = "next";
            context.arg = undefined$1;
          }

          return !! caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            // Exception thrown outside of any try block that could handle
            // it, so set the completion value of the entire function to
            // throw the exception.
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }

            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }

            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }

            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },

      abrupt: function(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev &&
              hasOwn.call(entry, "finallyLoc") &&
              this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry &&
            (type === "break" ||
             type === "continue") &&
            finallyEntry.tryLoc <= arg &&
            arg <= finallyEntry.finallyLoc) {
          // Ignore the finally entry if control is not jumping to a
          // location outside the try/catch block.
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },

      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" ||
            record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },

      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },

      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }

        // The context.catch method must only be called with a location
        // argument that corresponds to a known catch block.
        throw new Error("illegal catch attempt");
      },

      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          // Deliberately forget the last sent value so that we don't
          // accidentally pass it on to the delegate.
          this.arg = undefined$1;
        }

        return ContinueSentinel;
      }
    };

    // Regardless of whether this script is executing as a CommonJS module
    // or not, return the runtime object so that we can declare the variable
    // regeneratorRuntime in the outer scope, which allows this module to be
    // injected easily by `bin/regenerator --include-runtime script.js`.
    return exports;

  }(
    // If this script is executing as a CommonJS module, use module.exports
    // as the regeneratorRuntime namespace. Otherwise create a new empty
    // object. Either way, the resulting object will be used to initialize
    // the regeneratorRuntime variable at the top of this file.
    module.exports 
  ));

  try {
    regeneratorRuntime = runtime;
  } catch (accidentalStrictMode) {
    // This module should not be running in strict mode, so the above
    // assignment should always work unless something is misconfigured. Just
    // in case runtime.js accidentally runs in strict mode, we can escape
    // strict mode using a global Function call. This could conceivably fail
    // if a Content Security Policy forbids using Function, but in that case
    // the proper solution is to fix the accidental strict mode problem. If
    // you've misconfigured your bundler to force strict mode and applied a
    // CSP to forbid Function, and you're not willing to fix either of those
    // problems, please detail your unique predicament in a GitHub issue.
    Function("r", "regeneratorRuntime = r")(runtime);
  }
  }(runtime));

  var regenerator = runtime.exports;

  var template = {
    parentNode: "\n{\n  path: '##path##',##redirect##\n  component: ##layoutComponent##, \n  children: [\n    {\n      path: '##customPath##',##redirect##\n      name: '##name##', \n      fullPath:'##fullPath##',\n      component: ##component##,\n      meta: ##meta##,\n    },\n    ##children##\n  ],\n}\n",
    leafNode: "\n{\n      path: '##path##',\n      component: ##layoutComponent##, \n      children: [\n        {\n          path: '##customPath##',##redirect##\n          name: '##name##', \n          fullPath:'##fullPath##',\n          component: ##component##,\n          meta: ##meta##,\n        },\n      ],\n}\n",
    singleParentNode: "\n{\n  path: '##path##',\n  component: ##layoutComponent##, \n  children: [\n    {\n      path: '##customPath##',##redirect##\n      name: '##name##', \n      fullPath:'##fullPath##',\n      component: ##component##,\n      meta: ##meta##,\n    },\n  ],\n}\n",
    parentWithEntryNode: "\n{\n  path: '##path##',\n  component: ##layoutComponent##, \n  children: [\n    {\n      path: '##customPath##',##redirect##\n      name: '##name##', \n      fullPath:'##fullPath##',\n      component: ##component##,\n      meta: ##meta##,\n    },\n    ##children##\n  ],\n}\n"
  };

  var indent_size = 2;
  var indent_char = " ";
  var indent_with_tabs = false;
  var editorconfig = false;
  var eol = "\n";
  var end_with_newline = false;
  var indent_level = 0;
  var preserve_newlines = true;
  var max_preserve_newlines = 10;
  var space_in_paren = false;
  var space_in_empty_paren = false;
  var jslint_happy = false;
  var space_after_anon_function = false;
  var space_after_named_function = false;
  var brace_style = "collapse";
  var unindent_chained_methods = false;
  var break_chained_methods = false;
  var keep_array_indentation = false;
  var unescape_strings = false;
  var wrap_line_length = 0;
  var e4x = false;
  var comma_first = false;
  var operator_position = "before-newline";
  var indent_empty_lines = false;
  var templating = [
  	"auto"
  ];
  var jsPrettyConfig = {
  	indent_size: indent_size,
  	indent_char: indent_char,
  	indent_with_tabs: indent_with_tabs,
  	editorconfig: editorconfig,
  	eol: eol,
  	end_with_newline: end_with_newline,
  	indent_level: indent_level,
  	preserve_newlines: preserve_newlines,
  	max_preserve_newlines: max_preserve_newlines,
  	space_in_paren: space_in_paren,
  	space_in_empty_paren: space_in_empty_paren,
  	jslint_happy: jslint_happy,
  	space_after_anon_function: space_after_anon_function,
  	space_after_named_function: space_after_named_function,
  	brace_style: brace_style,
  	unindent_chained_methods: unindent_chained_methods,
  	break_chained_methods: break_chained_methods,
  	keep_array_indentation: keep_array_indentation,
  	unescape_strings: unescape_strings,
  	wrap_line_length: wrap_line_length,
  	e4x: e4x,
  	comma_first: comma_first,
  	operator_position: operator_position,
  	indent_empty_lines: indent_empty_lines,
  	templating: templating
  };

  var defaultLayoutComponent = '@/components/main';
  var placeholders = {
    component: '##component##',
    layoutComponent: '##layoutComponent##',
    meta: '##meta##',
    children: '##children##',
    path: '##path##',
    customPath: '##customPath##',
    name: '##name##',
    fullPath: '##fullPath##',
    redirect: '##redirect##'
  };
  var pagesPath = 'src/pages';

  var replacePathSplitForCommon = function replacePathSplitForCommon(str) {
    return str.replace(/\\/g, '/');
  };

  var replacePathSplit$1 = function replacePathSplit(str) {
    return replacePathSplitForCommon(str).replace(/\//g, path.sep);
  };

  var componentTemplates = {
    emptyComponent: "\n{\n    render(createElement) {\n        return createElement('router-view')\n    }\n}\n  ",
    dynamicImportComponent: function dynamicImportComponent(filePath) {
      return "() => import('@/".concat(replacePathSplitForCommon(filePath), "')");
    },
    defaultLayoutComponent: "() => import('".concat(defaultLayoutComponent, "')")
  };

  var getEmptyNode = function getEmptyNode(routePath) {
    return {
      asEntry: false,
      routePath: routePath,
      metaJSON: {},
      level: routePath.split('/').length,
      component: componentTemplates.emptyComponent
    };
  };

  function offsetParentMetaJSONInfo(nodes) {
    console.log('offset');
    var routeDic = {};
    var newNodes = [];
    nodes.forEach(function (node) {
      var pathNodes = node.routePath.split('/');
      if (pathNodes <= 1) return;

      var _loop = function _loop(i) {
        var subPath = pathNodes.slice(0, i).join('/');
        if (routeDic[subPath]) return {
          v: void 0
        };
        var findedNode = nodes.find(function (n) {
          return n.routePath === subPath;
        });

        if (!findedNode) {
          findedNode = getEmptyNode(subPath);
          newNodes.push(findedNode);
        }

        routeDic[subPath] = findedNode;
      };

      for (var i = 1; i < pathNodes.length; i++) {
        var _ret = _loop(i);

        if (_typeof(_ret) === "object") return _ret.v;
      }
    });
    nodes.splice.apply(nodes, [nodes.length, 0].concat(newNodes));
  }

  function getMetaInfos(_x) {
    return _getMetaInfos.apply(this, arguments);
  }

  function _getMetaInfos() {
    _getMetaInfos = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee3(cwd) {
      var dic, list, maxLevel, metaInfos, promises;
      return regenerator.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              dic = {};
              list = [];
              maxLevel = 0;
              _context3.next = 5;
              return globby__default['default']([replacePathSplitForCommon(path.join(pagesPath, "**/meta.json"))], {
                cwd: cwd
              });

            case 5:
              metaInfos = _context3.sent;
              promises = metaInfos.map( /*#__PURE__*/function () {
                var _ref3 = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2(n) {
                  var asEntry, entryFilePath, filePath, tempPath, routePath, level, metaJSONPath, metaJSON, component;
                  return regenerator.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          n = replacePathSplit$1(n);
                          asEntry = false;
                          entryFilePath = replacePathSplit$1(path.join(cwd, path.dirname(n), 'index.vue'));
                          _context2.next = 5;
                          return fs__default['default'].pathExists(entryFilePath);

                        case 5:
                          asEntry = _context2.sent;
                          filePath = replacePathSplit$1(path.dirname(n)).replace(/^src(\/|\\)/, '');
                          tempPath = replacePathSplit$1(path.relative(pagesPath, n));
                          tempPath = replacePathSplitForCommon(path.dirname(tempPath));
                          routePath = tempPath === '.' ? '/' : tempPath.split('/').map(function (m) {
                            return namingStyle.hyphen(m);
                          }).join('/');
                          level = routePath.length == 1 ? 1 : routePath.split('/').length;

                          if (level > maxLevel) {
                            maxLevel = level;
                          }

                          metaJSONPath = path.resolve(cwd, n);
                          _context2.next = 15;
                          return fs__default['default'].readJSON(metaJSONPath);

                        case 15:
                          metaJSON = _context2.sent;
                          component = componentTemplates.dynamicImportComponent(filePath);

                          if (!asEntry) {
                            component = componentTemplates.emptyComponent;
                          }

                          dic[routePath] = {
                            asEntry: asEntry,
                            filePath: filePath,
                            routePath: routePath,
                            metaJSON: metaJSON,
                            level: level,
                            component: component
                          };
                          list.push(dic[routePath]);

                        case 20:
                        case "end":
                          return _context2.stop();
                      }
                    }
                  }, _callee2);
                }));

                return function (_x4) {
                  return _ref3.apply(this, arguments);
                };
              }());
              _context3.next = 9;
              return Promise.all(promises);

            case 9:
              list.forEach(function (n) {
                if (n.metaJSON.index === undefined) {
                  n.metaJSON.index = 99;
                }
              });
              list.sort(function (a, b) {
                return a.metaJSON.index - b.metaJSON.index;
              });
              list.forEach(function (n) {
                return delete n.metaJSON.index;
              });
              offsetParentMetaJSONInfo(list);
              console.log(list);
              return _context3.abrupt("return", {
                list: list,
                maxLevel: maxLevel
              });

            case 15:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return _getMetaInfos.apply(this, arguments);
  }

  function makeTree(data) {
    var level = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
    var prefix = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
    var roots = data.filter(function (n) {
      return n.level === level && n.metaJSON.hidden !== true && n.routePath.indexOf(prefix) === 0;
    });
    var others = data.filter(function (n) {
      return n.level > level;
    });
    roots.filter(function (n) {
      return !data.some(function (m) {
        return m.level > n.level && m.routePath.indexOf(n.routePath) === 0;
      });
    }).forEach(function (n) {
      return n.isLeaf = true;
    });

    if (others.length > 0) {
      roots.forEach(function (n) {
        n.children = makeTree(others, level + 1, n.routePath);
        n.children.forEach(function (m) {
          return m.parent = n;
        });
      });
    }

    return roots;
  }

  function optionsToString(options) {
    options = options || {};
    var result = JSON.stringify(options);
    result = result.replace(/^{/, '');
    result = result.replace(/}$/, '');
    result = result ? "".concat(result, ",") : '';
    return result;
  }

  function createRouteTemplate(tree) {
    var totalString = '';
    var templateStrs = [];
    tree.forEach(function (node) {
      var templateStr = template.leafNode;
      var replaceTasks = [];

      if (node.level === 1 && node.isLeaf) {
        templateStr = template.singleParentNode;
      } else if (!node.isLeaf) {
        if (node.asEntry) {
          templateStr = template.parentWithEntryNode;
        } else {
          templateStr = template.parentNode;
        }
      } // 通用替换部分


      var metaInfo = node.metaJSON;
      replaceTasks.push({
        key: placeholders.meta,
        value: JSON.stringify(metaInfo)
      });
      var fullPath = "/".concat(node.routePath.replace(/^\//, ''));
      replaceTasks.push({
        key: placeholders.fullPath,
        value: fullPath
      });
      node.fullPath = fullPath;
      var name = metaInfo.name || "/".concat(node.routePath.replace(/^\//, ''));
      replaceTasks.push({
        key: placeholders.name,
        value: name
      });
      node.name = name;
      replaceTasks.push({
        key: placeholders.component,
        value: node.component
      });
      replaceTasks.push({
        key: placeholders.redirect,
        value: optionsToString({
          redirect: metaInfo.redirect ? metaInfo.redirect.split('/').map(function (n) {
            return !n ? n : namingStyle.hyphen(n);
          }).join('/') : undefined
        })
      });
      delete metaInfo.redirect;
      var layoutComponentTemplate = componentTemplates.defaultLayoutComponent;

      if (node.metaJSON.layoutComponent) {
        layoutComponentTemplate = componentTemplates.dynamicImportComponent(node.metaJSON.layoutComponent);
      } else if (node.parent) {
        layoutComponentTemplate = node.parent.component;
      }

      replaceTasks.push({
        key: placeholders.layoutComponent,
        value: layoutComponentTemplate
      });
      replaceTasks.push({
        key: placeholders.customPath,
        value: (metaInfo.path || '').replace(/^\/+/, '') || '/'
      });
      delete metaInfo.path;
      delete node.metaJSON.layoutComponent; // 父节点部分

      if (!node.isLeaf || node.level === 1) {
        var children = '';

        if (!node.isLeaf) {
          children = createRouteTemplate(node.children);
        }

        replaceTasks.push({
          key: placeholders.children,
          value: children
        });
        var routePath = node.routePath.split('/').pop();

        if (node.level === 1) {
          routePath = "/".concat(node.routePath);
        }

        replaceTasks.push({
          key: placeholders.path,
          value: routePath.replace(/\/+/g, '/')
        });
      } // 子节点部分


      if (node.isLeaf) {
        var _routePath = node.routePath.split('/').pop();

        replaceTasks.push({
          key: placeholders.path,
          value: _routePath
        });
      }

      replaceTasks.forEach(function (task) {
        templateStr = templateStr.replace(new RegExp(task.key, 'g'), task.value);
      });
      templateStrs.push(templateStr);
    });
    totalString = templateStrs.filter(function (n) {
      return !!n;
    }).join(',');
    return totalString;
  }

  function createMetaJSONTree(tree) {
    var metaJSONTree = [];
    tree.forEach(function (node) {
      var newNode = {
        path: "/".concat(node.routePath.replace(/^\//, '')),
        fullPath: node.fullPath,
        name: node.name,
        meta: node.metaJSON,
        children: undefined
      };
      metaJSONTree.push(newNode);

      if (node.children && node.children.length > 0) {
        newNode.children = newNode.children || [];
        newNode.children = newNode.children.concat(createMetaJSONTree(node.children));
      }
    });
    return metaJSONTree;
  }

  var main = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee(options, hideConsole) {
      var _ref2, cwd, outputRouteFilePath, rootLayoutComponent, newCwd, metaInfos, metaTree, finalStr, metaJSONTreeStr, tempRouteFilePath;

      return regenerator.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _ref2 = options || {}, cwd = _ref2.cwd, outputRouteFilePath = _ref2.outputRouteFilePath, rootLayoutComponent = _ref2.rootLayoutComponent;
              defaultLayoutComponent = rootLayoutComponent || defaultLayoutComponent;
              newCwd = replacePathSplit$1(cwd || path.resolve('.')); // 1.获取所有页面元信息

              _context.next = 5;
              return getMetaInfos(newCwd);

            case 5:
              metaInfos = _context.sent;
              // 2.转换成树形
              metaTree = makeTree(metaInfos.list); // 3.生成路由JS字符串

              finalStr = createRouteTemplate(metaTree); // 4.生成metaJSON字符串

              metaJSONTreeStr = JSON.stringify(createMetaJSONTree(metaTree)); // 4.写入文件

              tempRouteFilePath = outputRouteFilePath || path.join(newCwd, 'src', 'router', 'temp.router.js');
              fs__default['default'].removeSync(tempRouteFilePath);
              _context.next = 13;
              return fs__default['default'].outputFile(tempRouteFilePath, jsBeautify.js("\n    export default [".concat(finalStr, "];\n\n    export const metaJSONTree = ").concat(metaJSONTreeStr, ";\n    "), jsPrettyConfig));

            case 13:
              // 5.完成
              hideConsole === false && console.log('router create complete！', tempRouteFilePath, '\n');

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function main(_x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();

  var run = throttle__default['default'](main, 500, {
    leading: false,
    trailing: true
  });

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  var replacePathSplit = function replacePathSplit(str) {
    return str.replace(/\\/g, '/');
  };

  var vueAutoCreateRoute = (function (options, watchOptions) {
    var isWatch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    var newOptions = _objectSpread({}, options);

    var run$1 = run.bind(null, newOptions, newOptions.hideConsole);

    if (isWatch && "development" !== 'production') {
      // usePolling 开启路径轮询扫描,对文件夹名称修改仍能触发监听 ; interval 轮询间隔毫秒时长
      chokidar__namespace.watch(replacePathSplit(join(newOptions.cwd || '.', '**/meta.json')), _objectSpread({
        usePolling: true,
        interval: 500,
        ignored: '**/node_modules/**/*'
      }, watchOptions)).on('all', run$1);
    } else {
      run$1();
    }
  });

  var pluginName = 'autoCreateVueRouteWebpackPlugin';
  var subPlatform = {
    lib: 'wepback',
    dist: 'rollup',
    test: 'mocha&chai'
  };
  var first = true;
  var AutoCreateVueRouteWebpackPlugin = /*#__PURE__*/function () {
    function AutoCreateVueRouteWebpackPlugin(options, watchOptions) {
      var isWatch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      _classCallCheck(this, AutoCreateVueRouteWebpackPlugin);

      this.options = options;
      this.isWatch = isWatch;
      this.watchOptions = watchOptions;
    }

    _createClass(AutoCreateVueRouteWebpackPlugin, [{
      key: "apply",
      value: function apply(compiler) {
        var _this = this;

        compiler.hooks.beforeCompile.tap(pluginName, function (compilation) {
          if (first) {
            first = false;
            vueAutoCreateRoute(_this.options, _this.watchOptions, _this.isWatch);
          }
        });
      }
    }]);

    return AutoCreateVueRouteWebpackPlugin;
  }();

  exports.AutoCreateVueRouteWebpackPlugin = AutoCreateVueRouteWebpackPlugin;
  exports.subPlatform = subPlatform;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
